import swarm.*;
import swarm.objectbase.*;
import swarm.defobj.*;
import swarm.space.*;
import swarm.gui.*;
import swarm.collections.*;

public class Cell extends SwarmObjectImpl {
	public static final int HEALTHY=0;
	public int state,oldState;
	public int[] oldNeiState = new int[9];
	// oldNeiState
	// 0 1 2
	// 3 4 5
	// 6 7 8
	//        4 is itself. oldNeiState[4] is not used.
	int worldXSize,worldYSize,offset;
	double illState,k1,k2,g,initialState,rand;
	Array cellVector;

	public Cell(Zone aZone,int Offset,Array aVector){
		super(aZone);
		offset=Offset;
		cellVector=aVector;
	}

	public void initialize(){
		if(initialState == 0){
			if(offset >= worldXSize*(worldYSize + 1)/2 && offset <= worldXSize*(worldYSize + 1)/2 + k1) state = 1;
			else state = 0;
		}else{
			rand = Globals.env.uniformDblRand.getDoubleWithMin$withMax(0.0,1.0);
			if(rand<initialState)state = (int)(rand*(double)illState) ;
			else state = 0;
		}
	}
	public void setParams(int WorldXSize,int WorldYSize,double K1,double K2,double G,double IllState,double InitialState){
		worldXSize=WorldXSize;
		worldYSize=WorldYSize;
		k1=K1;
		k2=K2;
		g=G;
		illState = IllState;
		initialState = InitialState;
	}
	public int getState(){
		return state;
	}
	public void copyOldState(){
		oldState=state;
		boolean left_top = ((offset%worldXSize)==0 && (offset/worldXSize) == 0);
		boolean right_top = (((offset+1)%worldXSize)==0 && (offset/worldXSize) == 0);
		boolean left_bottom = ((offset%worldXSize)==0 && (offset/worldXSize) == (worldYSize-1));
		boolean right_bottom= (((offset+1)%worldXSize)==0 && (offset/worldXSize) == (worldYSize-1));
		boolean top = ((offset/worldXSize) == 0);
		boolean bottom = ((offset/worldXSize) == (worldYSize-1));
		boolean left = ((offset%worldXSize)==0);
		boolean right = (((offset+1)%worldXSize)==0);

		if(top==false && bottom==false && left==false && right==false){
			for(int i=0;i<9;i++){
				oldNeiState[i]=((Cell)cellVector.atOffset(offset+(i%3-1)+((i/3)-1)*worldXSize)).getState();
			}
		}else if(top == true && left_top == false && right_top == false){
			oldNeiState[0] = ((Cell)cellVector.atOffset(offset+(worldXSize*(worldYSize-1))-1)).getState();
			oldNeiState[1] = ((Cell)cellVector.atOffset(offset+(worldXSize*(worldYSize-1)))).getState();
			oldNeiState[2] = ((Cell)cellVector.atOffset(offset+(worldXSize*(worldYSize-1))+1)).getState();
			for(int i=3;i<9;i++){
				oldNeiState[i]=((Cell)cellVector.atOffset(offset+(i%3-1)+((i/3)-1)*worldXSize)).getState();
			}
		}else if(bottom == true && left_bottom == false && right_bottom == false){
			oldNeiState[6] = ((Cell)cellVector.atOffset(offset-(worldXSize*(worldYSize-1))-1)).getState();
			oldNeiState[7] = ((Cell)cellVector.atOffset(offset-(worldXSize*(worldYSize-1)))).getState();
			oldNeiState[8] = ((Cell)cellVector.atOffset(offset-(worldXSize*(worldYSize-1))+1)).getState();
			for(int i=0;i<6;i++){
				oldNeiState[i]=((Cell)cellVector.atOffset(offset+(i%3-1)+((i/3)-1)*worldXSize)).getState();
			}
		}
		if(left_top == true){
			oldNeiState[0] = ((Cell)cellVector.atOffset(offset+(worldXSize*worldYSize)-1)).getState();
			oldNeiState[3] = ((Cell)cellVector.atOffset(offset-1+worldXSize)).getState();
			oldNeiState[6] = ((Cell)cellVector.atOffset(offset-1+2*worldXSize)).getState();
		}else if(left_bottom == true){
			oldNeiState[0] = ((Cell)cellVector.atOffset(offset-1)).getState();
			oldNeiState[3] = ((Cell)cellVector.atOffset(offset-1+worldXSize)).getState();
			oldNeiState[6] = ((Cell)cellVector.atOffset(offset-(worldXSize*(worldYSize-2))-1)).getState();
		}else if (left == true){
			oldNeiState[0] = ((Cell)cellVector.atOffset(offset-1)).getState();
			oldNeiState[3] = ((Cell)cellVector.atOffset(offset-1+worldXSize)).getState();
			oldNeiState[6] = ((Cell)cellVector.atOffset(offset-1+2*worldXSize)).getState();
		}
		if(right_top == true){
			oldNeiState[2] = ((Cell)cellVector.atOffset(offset+(worldXSize*(worldYSize-2))+1)).getState();
			oldNeiState[5] = ((Cell)cellVector.atOffset(offset+1-worldXSize)).getState();
			oldNeiState[8] = ((Cell)cellVector.atOffset(offset+1)).getState();
 		}else if(right_bottom == true){
			oldNeiState[2] = ((Cell)cellVector.atOffset(offset+1-2*worldXSize)).getState();
			oldNeiState[5] = ((Cell)cellVector.atOffset(offset+1-worldXSize)).getState();
			oldNeiState[8] = ((Cell)cellVector.atOffset(offset-(worldXSize*worldYSize)+1)).getState();
		}else if (right == true){
 			oldNeiState[2] = ((Cell)cellVector.atOffset(offset+1-2*worldXSize)).getState();
 			oldNeiState[5] = ((Cell)cellVector.atOffset(offset+1-worldXSize)).getState();
 			oldNeiState[8] = ((Cell)cellVector.atOffset(offset+1)).getState();
 		}

	}

	public void newState(){
		int a,b;
		a=b=0;
		double neiStates = 0;
		if(state>=illState){
			state = HEALTHY;
		}else{
			neiStates = state;
			for(int i=0;i<9;i++){
				if(i!=4){
					neiStates += oldNeiState[i];
					if(oldNeiState[i]==illState)b++;
					else if(oldNeiState[i]!=HEALTHY)a++;
				}
			}
			if(state == HEALTHY){
				state = (int)((double)a/k1 + (double)b/k2);
			}else{
				state = (int)(neiStates/((double)(a+b+1)) + g);
			}
		}
	}
}
